@echo OFF
setlocal

chdir /d "%~dp0"

copy /Y "removeTMSM.bat" c:\ >NUL 2>&1
if ERRORLEVEL 1 (
	echo --------------------------------------------------------
	echo --------------------------------------------------------
	echo --------------------------------------------------------
	echo Please run this script with Administrator privilege!!
	echo --------------------------------------------------------
	echo --------------------------------------------------------
	echo --------------------------------------------------------
	pause
	goto :EOF
) else (
	del /f /q c:\removeTMSM.bat
)


echo === Version Support ===
echo Trend Micro Security (for Mac) 1.5, 1.6, 2.0, 2.1
echo Windows Server 2003, 2008, 2012, 2012 R2
echo Architecture: Intel x86, x64


echo === Stage 1. Init parameter ===
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
	set WOW6432NODE=Wow6432Node\
) else (
	set WOW6432NODE=
)

set SQLVER=sql2005
FOR /F "tokens=2*" %%A IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\TMSM\MSSQLServer\CurrentVersion" /v "CurrentVersion"') DO (set SQLBUILDNUM=%%B)
if "%SQLBUILDNUM%" NEQ "" (
    for /f "delims=. tokens=1" %%a in ("%SQLBUILDNUM%") do (
        set MAJORVER=%%a
    )
)
if "%MAJORVER%" EQU "10" (
    set SQLVER=sql2008
)

ver | findstr /i "Version\ 6\.2\." > nul
IF %ERRORLEVEL% EQU 0 set SQLVER=sql2008

ver | findstr /i "Version\ 6\.3\." > nul
IF %ERRORLEVEL% EQU 0 set SQLVER=sql2008

reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\OfficeScan\service\Information" /v "Local_Path" >nul 2>&1
if %errorlevel% NEQ 0 (
	echo Can't find OSCE local path.
	goto:END
)
FOR /F "tokens=2*" %%A IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\OfficeScan\service\Information" /v "Local_Path"') DO (set PCCSRVPATH=%%B)
set OSCEPATH=%PCCSRVPATH%\..
set SQLEXE=%OSCEPATH%\PCCSRV\Admin\Utility\SQL\SQL.exe
set SQL2008EXE=%OSCEPATH%\PCCSRV\Admin\Utility\SQL\SQL_2008.exe
set DBINSTANCE=TMSM

set OSVER=NT6
ver | findstr /i "Version\ 5\." > nul
IF %ERRORLEVEL% EQU 0 set OSVER=NT5

FOR /F "tokens=2*" %%A IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\TMSM" /v "MQBrokerPort"') DO (set /a MQPORT=%%B)
if "%MQPORT%" == "" (
	echo ActiveMQ SSL port didn't be found at registry set port to 61617
	set MQPORT=61617
)
echo AcitveMQ SSL port %MQPORT%

echo === Stage 2. Stop and delete the services ===
net stop TMSMMainService /Y
net stop ActiveMQ4TMSM /Y
net stop OfcAosMgr /Y
taskkill /IM TMSMMainService.exe /F
taskkill /IM OfcAosMgr.exe /F
sc delete TMSMMainService
sc delete ActiveMQ4TMSM


echo === Stage 3. Remove the dependent application ===
if %SQLVER% == sql2005 (
	"%SQLEXE%" /qn REMOVE=SQL_Engine INSTANCENAME=%DBINSTANCE%
)
if %SQLVER% == sql2008 (
	if exist "%SQL2008EXE%" (
		"%SQL2008EXE%" /Q /ACTION=Uninstall /FEATURES=SQLEngine /INSTANCENAME=%DBINSTANCE%
	) else (
		"%SQLEXE%" /Q /ACTION=Uninstall /FEATURES=SQLEngine /INSTANCENAME=%DBINSTANCE%
	)
)
net stop MSSQL$TMSM /Y
sc delete MSSQL$TMSM

echo === Stage 4. Remove registered ports on Windows Firewall ===
:: "netsh advfirewall" supports vista, server2008 and later
if "%OSVER%" == "NT5" (
	netsh firewall delete portopening protocol=TCP port=%MQPORT%
) else (
	netsh advfirewall firewall delete rule name="ActiveMQ for Trend Micro Security" protocol=TCP localport=%MQPORT%
)

echo === Stage 5. Remove and modify the registry keys ===
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\TMSM" /f
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\OfficeScan\service\Aos\OSCE_ADDON_TMSM" /f
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Windows\CurrentVersion\Uninstall\{AA096B41-7254-4F59-9672-4BB31C3A6570}" /f
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-18\Products\14B690AA452795F46927B43BC1A35607" /f
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\Installer\Products\14B690AA452795F46927B43BC1A35607" /f
reg add "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%TrendMicro\OfficeScan\service\AoS" /v "OSCE_Addon_Service_CompList_Version" /t REG_SZ /d "1.0.0001" /f


echo === Stage 6. Remove the files ===
del /F/Q  "%OSCEPATH%\PCCSRV\Download\Product\AddonSvcTMSM.zip"
del /F/Q  "%OSCEPATH%\PCCSRV\Download\Product\AddonSvcTMSMAgent.zip"
del /F/Q  "%OSCEPATH%\PCCSRV\Download\AddonSvcTMSM.zip"
del /F/Q  "%OSCEPATH%\PCCSRV\Download\AddonSvcTMSMAgent.zip"
del /F/Q "%OSCEPATH%\Addon\TMSM"
rd /Q/S "%OSCEPATH%\Addon\TMSM"


echo === Stage 7. Force remove the database ===
FOR /F "tokens=2*" %%A IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\TMSM\Setup" /v "SQLPath"') DO (set INSTANCEPATH=%%B)
if "%INSTANCEPATH%" NEQ "" (	
	del /F/Q "%INSTANCEPATH%\.."
	rd /Q/S "%INSTANCEPATH%\.."
)
reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\TMSM" /f

FOR /F "tokens=2*" %%A IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\Instance Names\SQL" /v "TMSM"') DO (set INSTANCENAME=%%B)
if "%INSTANCENAME%" NEQ "" (
	reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\%INSTANCENAME%" /f
	reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%Microsoft\Microsoft SQL Server\Instance Names\SQL" /v "TMSM" /f
)


echo === Stage 8. Start PLM ===
sc start OfcAosMgr

goto END


:__ForceExit
:: Creates a syntax error, stops immediately
()
goto:EOF

:END
